Index: trunk/src/user32/Makefile
===================================================================
--- trunk/src/user32/Makefile	(revision 576)
+++ trunk/src/user32/Makefile	(revision 577)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.13 1999-08-16 16:28:04 sandervl Exp $
+# $Id: Makefile,v 1.14 1999-08-19 12:53:55 sandervl Exp $
 
 #
@@ -45,9 +45,9 @@
 
 user32.obj: user32.cpp $(PDWIN32_INCLUDE)\wndproc.h \
-            $(PDWIN32_INCLUDE)\wndclass.h icon.h syscolor.h
+            $(PDWIN32_INCLUDE)\wndclass.h $(PDWIN32_INCLUDE)\winicon.h syscolor.h
 resstring.obj: resstring.cpp resstring.h
 char.obj: char.cpp user32.h
 loadres.obj: loadres.cpp user32.h
-icon.obj: icon.cpp icon.h
+icon.obj: icon.cpp $(PDWIN32_INCLUDE)\winicon.h
 menu.obj: menu.cpp user32.h
 syscolor.obj: syscolor.cpp syscolor.h
Index: trunk/src/user32/icon.cpp
===================================================================
--- trunk/src/user32/icon.cpp	(revision 576)
+++ trunk/src/user32/icon.cpp	(revision 577)
@@ -1,13 +1,11 @@
-/* $Id: icon.cpp,v 1.4 1999-06-19 10:54:47 sandervl Exp $ */
+/* $Id: icon.cpp,v 1.5 1999-08-19 12:53:55 sandervl Exp $ */
 
-/*
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
 /*
  * Win32 icon conversion functions for OS/2
  *
  * Copyright 1998 Sander van Leeuwen
+ *
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
  *
  */
@@ -25,15 +23,9 @@
 #include <iostream.h>
 #include <string.h>
-#define  _ICON_C_
 
-#define DWORD   ULONG
-#define LPVOID  VOID *
-#define WORD    USHORT 
-#define WCHAR   USHORT
-#define HANDLE  ULONG
-#define LPWSTR  WCHAR *
+#include <win32type.h>
 
-#include "icon.h"
-#include "misc.h"
+#include <winicon.h>
+#include <misc.h>
 
 //******************************************************************************
Index: trunk/src/user32/icon.h
===================================================================
--- trunk/src/user32/icon.h	(revision 576)
+++ 	(revision )
@@ -1,73 +1,0 @@
-/* $Id: icon.h,v 1.3 1999-06-10 16:50:39 phaller Exp $ */
-
-/*
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
-/*
- * Win32 icon conversion functions for OS/2
- *
- * Copyright 1998 Sander van Leeuwen
- *
- */
-#ifndef __ICON_H__
-#define __ICON_H__
-
-extern "C" PBYTE ConvertWin32Icon(PBYTE presbits, DWORD dwResSize, DWORD *OS2ResSize);
-extern "C" void  FreeIcon(void *os2icon);
-
-
-#ifdef _ICON_C_
-
-#pragma pack(1)
-
-typedef struct {
-  WORD   wReserved;          // Currently zero
-  WORD   wType;              // 1 for icons
-  WORD   wCount;             // Number of components
-//Fout in docs, geen padding
-//  WORD   padding;            // filler for DWORD alignment
-} IconHeader;
-
-typedef struct tagWINBITMAPINFOHEADER{
-        DWORD      biSize;
-        LONG       biWidth;
-        LONG       biHeight;
-        WORD       biPlanes;
-        WORD       biBitCount;
-        DWORD      biCompression;
-        DWORD      biSizeImage;
-        LONG       biXPelsPerMeter;
-        LONG       biYPelsPerMeter;
-        DWORD      biClrUsed;
-        DWORD      biClrImportant;
-} WINBITMAPINFOHEADER;
-
-typedef struct
-{
-   BYTE                      blue;
-   BYTE                      green;
-   BYTE                      red;
-   BYTE                      res;
-}  RGBQUAD;
-
-//The next portion is repeated for each component resource:
-typedef struct {
-  BYTE   bWidth;
-  BYTE   bHeight;
-  BYTE   bColorCount;
-  BYTE   bReserved;
-  WORD   wPlanes;
-  WORD   wBitCount;
-  DWORD  lBytesInRes;
-  WORD   wNameOrdinal;       // Points to component
-//Fout in docs, geen padding
-//  WORD   padding;            // filler for DWORD alignment
-} ResourceDirectory;
-
-#pragma pack()
-
-#endif
-
-#endif
Index: trunk/src/user32/new/icon.cpp
===================================================================
--- trunk/src/user32/new/icon.cpp	(revision 576)
+++ trunk/src/user32/new/icon.cpp	(revision 577)
@@ -1,3 +1,3 @@
-/* $Id: icon.cpp,v 1.2 1999-07-20 15:46:53 sandervl Exp $ */
+/* $Id: icon.cpp,v 1.3 1999-08-19 12:53:56 sandervl Exp $ */
 
 /*
@@ -23,15 +23,9 @@
 #include <iostream.h>
 #include <string.h>
-#define  _ICON_C_
 
-#define DWORD   ULONG
-#define LPVOID  VOID *
-#define WORD    USHORT 
-#define WCHAR   USHORT
-#define HANDLE  ULONG
-#define LPWSTR  WCHAR *
+#include <win32type.h>
 
-#include "icon.h"
-#include "misc.h"
+#include <winicon.h>
+#include <misc.h>
 
 //******************************************************************************
Index: trunk/src/user32/new/icon.h
===================================================================
--- trunk/src/user32/new/icon.h	(revision 576)
+++ 	(revision )
@@ -1,73 +1,0 @@
-/* $Id: icon.h,v 1.1 1999-07-14 08:35:34 sandervl Exp $ */
-
-/*
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
-/*
- * Win32 icon conversion functions for OS/2
- *
- * Copyright 1998 Sander van Leeuwen
- *
- */
-#ifndef __ICON_H__
-#define __ICON_H__
-
-extern "C" PBYTE ConvertWin32Icon(PBYTE presbits, DWORD dwResSize, DWORD *OS2ResSize);
-extern "C" void  FreeIcon(void *os2icon);
-
-
-#ifdef _ICON_C_
-
-#pragma pack(1)
-
-typedef struct {
-  WORD   wReserved;          // Currently zero
-  WORD   wType;              // 1 for icons
-  WORD   wCount;             // Number of components
-//Fout in docs, geen padding
-//  WORD   padding;            // filler for DWORD alignment
-} IconHeader;
-
-typedef struct tagWINBITMAPINFOHEADER{
-        DWORD      biSize;
-        LONG       biWidth;
-        LONG       biHeight;
-        WORD       biPlanes;
-        WORD       biBitCount;
-        DWORD      biCompression;
-        DWORD      biSizeImage;
-        LONG       biXPelsPerMeter;
-        LONG       biYPelsPerMeter;
-        DWORD      biClrUsed;
-        DWORD      biClrImportant;
-} WINBITMAPINFOHEADER;
-
-typedef struct
-{
-   BYTE                      blue;
-   BYTE                      green;
-   BYTE                      red;
-   BYTE                      res;
-}  RGBQUAD;
-
-//The next portion is repeated for each component resource:
-typedef struct {
-  BYTE   bWidth;
-  BYTE   bHeight;
-  BYTE   bColorCount;
-  BYTE   bReserved;
-  WORD   wPlanes;
-  WORD   wBitCount;
-  DWORD  lBytesInRes;
-  WORD   wNameOrdinal;       // Points to component
-//Fout in docs, geen padding
-//  WORD   padding;            // filler for DWORD alignment
-} ResourceDirectory;
-
-#pragma pack()
-
-#endif
-
-#endif
Index: trunk/src/user32/new/makefile
===================================================================
--- trunk/src/user32/new/makefile	(revision 576)
+++ trunk/src/user32/new/makefile	(revision 577)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.24 1999-08-16 16:28:04 sandervl Exp $
+# $Id: makefile,v 1.25 1999-08-19 12:53:56 sandervl Exp $
 
 #
@@ -55,9 +55,9 @@
 
 user32.obj: user32.cpp $(PDWIN32_INCLUDE)\wndproc.h \
-            icon.h syscolor.h
+            $(PDWIN32_INCLUDE)\winicon.h syscolor.h
 resstring.obj: resstring.cpp resstring.h
 char.obj: char.cpp user32.h
 loadres.obj: loadres.cpp user32.h
-icon.obj: icon.cpp icon.h
+icon.obj: icon.cpp $(PDWIN32_INCLUDE)\winicon.h
 winmenu.obj: winmenu.cpp user32.h $(PDWIN32_INCLUDE)\winres.h
 syscolor.obj: syscolor.cpp syscolor.h
@@ -96,5 +96,5 @@
 winaccel.obj:     winaccel.cpp  $(PDWIN32_INCLUDE)\winres.h
 winscrollbar.obj: winscrollbar.cpp
-winicon.obj:    winicon.cpp
+winicon.obj:    winicon.cpp $(PDWIN32_INCLUDE)\winicon.h
 
 pmwindow.obj:   pmwindow.cpp win32class.h win32wnd.h win32dlg.h pmwindow.h win32wndchild.h $(PDWIN32_INCLUDE)\wprocess.h  oslibgdi.h
Index: trunk/src/user32/new/user32.cpp
===================================================================
--- trunk/src/user32/new/user32.cpp	(revision 576)
+++ trunk/src/user32/new/user32.cpp	(revision 577)
@@ -1,3 +1,3 @@
-/* $Id: user32.cpp,v 1.13 1999-07-25 20:00:52 cbratschi Exp $ */
+/* $Id: user32.cpp,v 1.14 1999-08-19 12:53:56 sandervl Exp $ */
 
 /*
@@ -30,5 +30,5 @@
 
 #include "user32.h"
-#include "icon.h"
+#include <winicon.h>
 #include "usrcall.h"
 #include "syscolor.h"
Index: trunk/src/user32/new/winicon.cpp
===================================================================
--- trunk/src/user32/new/winicon.cpp	(revision 576)
+++ trunk/src/user32/new/winicon.cpp	(revision 577)
@@ -1,3 +1,3 @@
-/* $Id: winicon.cpp,v 1.1 1999-07-25 17:47:25 sandervl Exp $ */
+/* $Id: winicon.cpp,v 1.2 1999-08-19 12:53:57 sandervl Exp $ */
 /*
  * Win32 Icon Code for OS/2
@@ -11,5 +11,5 @@
  */
 #include <os2win.h>
-#include "icon.h"
+#include <winicon.h>
 
 //******************************************************************************
Index: trunk/src/user32/user32.cpp
===================================================================
--- trunk/src/user32/user32.cpp	(revision 576)
+++ trunk/src/user32/user32.cpp	(revision 577)
@@ -1,3 +1,3 @@
-/* $Id: user32.cpp,v 1.20 1999-08-03 21:22:33 sandervl Exp $ */
+/* $Id: user32.cpp,v 1.21 1999-08-19 12:53:55 sandervl Exp $ */
 
 /*
@@ -25,5 +25,4 @@
 #include "wndproc.h"
 #include "wndclass.h"
-#include "icon.h"
 #include "usrcall.h"
 #include "syscolor.h"
@@ -32,4 +31,5 @@
 #include <stdlib.h>
 #include <string.h>
+#include <winicon.h>
 
 //undocumented stuff
@@ -1398,5 +1398,4 @@
 }
 //******************************************************************************
-//******************************************************************************
 HWND WIN32API CreateMDIWindowA(LPCSTR arg1, LPCSTR arg2, DWORD arg3,
                                int arg4, int arg5, int arg6, int arg7,