Index: /trunk/configure.cmd
===================================================================
--- /trunk/configure.cmd	(revision 586)
+++ /trunk/configure.cmd	(revision 587)
@@ -644,7 +644,13 @@
 
     G.CFG_ACCESSIBILITY = "no"
+    G.CFG_PHONON = "no"
     G.CFG_MULTIMEDIA = "no"
     G.CFG_IPV6 = "no"
     G.CFG_NIS = "no"
+    G.CFG_DBUS = "no"
+    G.CFG_OPENSSL = "no"
+    G.CFG_QGTKSTYLE = "no"
+    G.CFG_LARGEFILE = "no"
+    G.CFG_PRECOMPILE = "no" /* GCC 4.4.2 crashes with PCH */
 
     /*--------------------------------------------------------------------------
@@ -911,18 +917,4 @@
      * structure similar to ./configure */
 
-    /* enable all image formats and ZLIB by default */
-    if (G.CFG_GIF == "auto")    then G.CFG_GIF = "yes"
-    if (G.CFG_TIFF == "auto")   then G.CFG_TIFF = "yes"
-    if (G.CFG_PNG == "auto")    then G.CFG_PNG = "yes"
-    if (G.CFG_JPEG == "auto")   then G.CFG_JPEG = "yes"
-    if (G.CFG_MNG == "auto")    then G.CFG_MNG = "yes"
-    if (G.CFG_ZLIB == "auto")   then G.CFG_ZLIB = "yes"
-
-    if (G.CFG_QGTKSTYLE == "auto")  then G.CFG_QGTKSTYLE = "no"
-    if (G.CFG_OPENSSL == "auto")    then G.CFG_OPENSSL = "no"
-    if (G.CFG_DBUS == "auto")       then G.CFG_DBUS = "no"
-
-    if (G.CFG_GRAPHICS_SYSTEM == "default") then G.CFG_GRAPHICS_SYSTEM = "raster"
-
     /* auto-detect SQL-modules support */
     do i = 1 to words(G.CFG_SQL_AVAILABLE)
@@ -958,9 +950,34 @@
     end
 
+    if (G.CFG_WEBKIT == "auto") then
+        G.CFG_WEBKIT = "no" /* WebKit seems to require G++ >= 3.4.x */
+
     /*--------------------------------------------------------------------------
      ask for all that hasn't been auto-detected or specified in the arguments
     --------------------------------------------------------------------------*/
 
-    /* nothing so far */
+    /* We don't ask anything so far. Just apply "yes" to "auto" options */
+
+    /* enable all image formats and ZLIB by default */
+    if (G.CFG_GIF == "auto")    then G.CFG_GIF = "yes"
+    if (G.CFG_TIFF == "auto")   then G.CFG_TIFF = "yes"
+    if (G.CFG_PNG == "auto")    then G.CFG_PNG = "yes"
+    if (G.CFG_JPEG == "auto")   then G.CFG_JPEG = "yes"
+    if (G.CFG_MNG == "auto")    then G.CFG_MNG = "yes"
+    if (G.CFG_ZLIB == "auto")   then G.CFG_ZLIB = "yes"
+
+    if (G.CFG_GRAPHICS_SYSTEM == "default") then G.CFG_GRAPHICS_SYSTEM = "raster"
+
+    if (G.CFG_SM == "auto")             then G.CFG_SM = "yes"
+    if (G.CFG_STL == "auto")            then G.CFG_STL = "yes"
+    if (G.CFG_CONCURRENT == "auto")     then G.CFG_CONCURRENT = "yes"
+    if (G.CFG_PHONON == "auto")         then G.CFG_PHONON = "yes"
+    if (G.CFG_MULTIMEDIA == "auto")     then G.CFG_MULTIMEDIA = "yes"
+    if (G.CFG_DECLARATIVE == "auto")    then G.CFG_DECLARATIVE = "yes"
+    if (G.CFG_SCRIPT == "auto")         then G.CFG_SCRIPT = "yes"
+    if (G.CFG_SCRIPTTOOLS == "auto")    then G.CFG_SCRIPTTOOLS = "yes"
+    if (G.CFG_QGTKSTYLE == "auto")      then G.CFG_QGTKSTYLE = "yes"
+    if (G.CFG_OPENSSL == "auto")        then G.CFG_OPENSSL = "yes"
+    if (G.CFG_DBUS == "auto")           then G.CFG_DBUS = "yes"
 
     /*--------------------------------------------------------------------------
@@ -968,9 +985,7 @@
     --------------------------------------------------------------------------*/
 
-    /* enable Qt 3 support functionality */
     if (G.CFG_QT3SUPPORT == "yes") then
         G.QT_CONFIG = Join(G.QT_CONFIG, "qt3support")
 
-    /* enable Phonon */
     if (G.CFG_PHONON == "yes") then do
         G.QT_CONFIG = Join(G.QT_CONFIG, "phonon")
@@ -981,5 +996,4 @@
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_PHONON")
 
-    /* disable accessibility */
     if (G.CFG_ACCESSIBILITY == "no") then
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_ACCESSIBILITY")
@@ -987,5 +1001,4 @@
         G.QT_CONFIG = Join(G.QT_CONFIG, "accessibility")
 
-    /* disable opengl */
     if (G.CFG_OPENGL == "yes") then
         G.QT_CONFIG = Join(G.QT_CONFIG, "opengl")
@@ -1161,7 +1174,4 @@
         G.CFG_EXCEPTIONS = "no"
 
-    if (G.CFG_CONCURRENT == "auto") then
-        G.CFG_CONCURRENT = "yes"
-
     if (G.CFG_CONCURRENT == "no") then
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_CONCURRENT")
@@ -1173,5 +1183,5 @@
     end
     if (G.CFG_XMLPATTERNS == "auto" & G.CFG_EXCEPTIONS \== "no") then
-        G.CFG_XMLPATTERNS = "yes" /* QtXmlPatterns is fine for GCC 3.3.x */
+        G.CFG_XMLPATTERNS = "yes"
     else if (G.CFG_EXCEPTIONS == "no") then
         G.CFG_XMLPATTERNS = "no"
@@ -1181,7 +1191,4 @@
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_XMLPATTERNS")
 
-    if (G.CFG_MULTIMEDIA == "auto") then
-        G.CFG_MULTIMEDIA == "yes"
-
     if (G.CFG_MULTIMEDIA == "no") then
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_MULTIMEDIA")
@@ -1197,14 +1204,8 @@
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_SVG")
 
-    if (G.CFG_DECLARATIVE == "auto") then
-        G.CFG_DECLARATIVE = "yes"
-
     if (G.CFG_DECLARATIVE == "yes") then
         G.QT_CONFIG = Join(G.QT_CONFIG, "declarative")
     else
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_DECLARATIVE")
-
-    if (G.CFG_WEBKIT == "auto") then
-        G.CFG_WEBKIT = "no" /* WebKit seems to require G++ >= 3.4.x */
 
     if (G.CFG_WEBKIT == "yes") then
@@ -1217,14 +1218,8 @@
     end
 
-    if (G.CFG_SCRIPT == "auto") then
-        G.CFG_SCRIPT = "yes"
-
     if (G.CFG_SCRIPT == "yes") then
         G.QT_CONFIG = Join(G.QT_CONFIG, "script")
     else
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_SCRIPT")
-
-    if (G.CFG_SCRIPTTOOLS == "auto") then
-        G.CFG_SCRIPTTOOLS = "yes"
 
     if (G.CFG_SCRIPTTOOLS == "yes") then
@@ -1478,8 +1473,8 @@
     if (G.CFG_OPENSSL == "linked") then
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_LINKED_OPENSSL")
+*/
 
     if (G.CFG_SM == "no") then
         G.QCONFIG_FLAGS = Join(G.QCONFIG_FLAGS, "QT_NO_SESSIONMANAGER")
-*/
 
     /* do primitive sorting (the list is not so big so it should be fine) */